leetcode刷题日记:190. Reverse Bits(颠倒二进制位)和191. Number of 1 Bits( 位1的个数)

190. Reverse Bits(颠倒二进制位)

题目要求我们将一个数的二进制位进行颠倒,画出图示如下(以8位二进制为例):

显然对于这种问题我们需要用到位操作,我们需要将原数的每一位取出来然后颠倒之后放进另一个数。

我们需要先知道离散数学中的几个公式 p ∨ 1 = 1 p ∨ 0 = p p ∧ 1 = p p ∧ 0 = 0 p\lor 1 = 1\\p\lor 0=p\\p\land 1 = p\\p\land 0 = 0 p∨1=1p∨0=pp∧1=pp∧0=0

知道上述的公式之后我们就可以对数进行取出位数。

如下图所示

也就是说我们要取出哪一位就让哪一位&上1就行了。

但是如何控制对应位为1而其他位为0呢?我们知道c语言中移位操作>>与<<,分别代表左移与右移,让对应位为1我们只需要让1进行<<操作就行。

经过移位与&操作我们可以得到一个除了要取出位为原二进制数中对应位之外,其余位全为0的数。

现在取出哪一位的问题已经解决了,我们知道 p ∨ 0 = = p p\lor0==p p∨0==p也就是说我们要保证接收对应位的数的对应位等于0,其余的均不许要进行改变,因为我们取出数的位除了取出的那一位其余位全为0,并不会改变我们的接收数。由此我们有了以下的思路。

因为有符号整型的数在进行移位操作的时候并不能操作符号位所以我们需要先进行符号位的改变。或者使用无符号整型。

c 复制代码
uint32_t reverseBits(uint32_t n) {
    int x = 0;
    if(n%2==0){
        x = 0;
    }else{
        x = INT_MIN;
    }
    for(int i =0; i<31; i++){
        n = n>>1;
        x |= ((n&1)<<(30-i));
    }
    return x;
}

运行结果截图:

191. Number of 1 Bits( 位1的个数)

经过上面这一题之后我们已经知道怎么取出对应位了,取出对应位之后判断是否为1就行了。

c 复制代码
int hammingWeight(uint32_t n) {
    int count = 0;
    while(n){
        if(n&1){
            count++;  
        }
        n=n>>1;
    }
    return count;
}

运行结果截图:

相关推荐
w_zero_one4 小时前
动态规划(三)
java·算法·动态规划
Logic1015 小时前
C语言/数据结构贡献法题解:数组权值——所有连续子数组中不同数字个数之和(O(n)解法)
c语言·数据结构·算法·数组·时间复杂度·贡献法·哈希记录
DongQiShanRen5 小时前
六根硬件映射(中):双站校验、生克闭环与驱动接口
数据库·人工智能·算法·rust·哈希算法·集成学习
mmmmath_35 小时前
LeetCode.637.二叉树的层平均值
算法·leetcode
青少儿编程课堂5 小时前
蓝桥杯·全国青少年信息素养大赛·电子学会C/C++考级:并查集连通块与朋友圈问题解析
c++·python·算法·bfs·信息学竞赛
Tisfy5 小时前
LeetCode 2913.子数组不同元素数目的平方和 I:第一题先常数很大的O(n^2)
算法·leetcode·题解·模拟·暴力
罗湖老棍子5 小时前
[USACO05NOV] Asteroids G(洛谷-P7368)
算法·图论·二分图匹配·最大匹配·最小顶点覆盖
我命由我123455 小时前
准入类与水平类职业资格
笔记·学习·职场和发展·产品运营·求职招聘·职场发展·产品经理
AI技术新视界5 小时前
Harness^2:递归自进化智能体Harnessing框架
人工智能·深度学习·算法·harness·rsi
这个DBA有点耶5 小时前
MySQL B-tree索引并发控制优化:写密集场景的锁瓶颈与内核级解法
java·数据库·程序人生·算法·database·dba